/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.api;

import io.docs_dispatcher.client.ApiCallback;
import io.docs_dispatcher.client.ApiClient;
import io.docs_dispatcher.client.ApiException;
import io.docs_dispatcher.client.ApiResponse;
import io.docs_dispatcher.client.Configuration;
import io.docs_dispatcher.client.Pair;
import io.docs_dispatcher.client.ProgressRequestBody;
import io.docs_dispatcher.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.docs_dispatcher.client.model.Service;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ExternalServicesWebhooksApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public ExternalServicesWebhooksApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ExternalServicesWebhooksApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for webhooksHandleWebHook
     * @param dispatcherService The service used to handle the request (required)
     * @param provider The provider name from which the callback comes. (required)
     * @param body  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call webhooksHandleWebHookCall(Service dispatcherService, String provider, Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/api/webhooks/{dispatcherService}/providers/{provider}/endpoint.json"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()))
            .replace("{" + "provider" + "}", localVarApiClient.escapeString(provider.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call webhooksHandleWebHookValidateBeforeCall(Service dispatcherService, String provider, Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling webhooksHandleWebHook(Async)");
        }

        // verify the required parameter 'provider' is set
        if (provider == null) {
            throw new ApiException("Missing the required parameter 'provider' when calling webhooksHandleWebHook(Async)");
        }

        return webhooksHandleWebHookCall(dispatcherService, provider, body, _callback);

    }

    /**
     * Handle the external service webhook calls. Service type and provider should be present in the path. Payload should be present in the body and could be anything.
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param provider The provider name from which the callback comes. (required)
     * @param body  (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public Object webhooksHandleWebHook(Service dispatcherService, String provider, Object body) throws ApiException {
        ApiResponse<Object> localVarResp = webhooksHandleWebHookWithHttpInfo(dispatcherService, provider, body);
        return localVarResp.getData();
    }

    /**
     * Handle the external service webhook calls. Service type and provider should be present in the path. Payload should be present in the body and could be anything.
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param provider The provider name from which the callback comes. (required)
     * @param body  (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Object> webhooksHandleWebHookWithHttpInfo(Service dispatcherService, String provider, Object body) throws ApiException {
        okhttp3.Call localVarCall = webhooksHandleWebHookValidateBeforeCall(dispatcherService, provider, body, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Handle the external service webhook calls. Service type and provider should be present in the path. Payload should be present in the body and could be anything. (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param provider The provider name from which the callback comes. (required)
     * @param body  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call webhooksHandleWebHookAsync(Service dispatcherService, String provider, Object body, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = webhooksHandleWebHookValidateBeforeCall(dispatcherService, provider, body, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
